Merge branch 'sb/repack-in-c'
[alt-git.git] / git-am.sh
blob7ea40fe6449b665713a8272f125936edf632189b
1 #!/bin/sh
3 # Copyright (c) 2005, 2006 Junio C Hamano
5 SUBDIRECTORY_OK=Yes
6 OPTIONS_KEEPDASHDASH=
7 OPTIONS_SPEC="\
8 git am [options] [(<mbox>|<Maildir>)...]
9 git am [options] (--continue | --skip | --abort)
11 i,interactive run interactively
12 b,binary* (historical option -- no-op)
13 3,3way allow fall back on 3way merging if needed
14 q,quiet be quiet
15 s,signoff add a Signed-off-by line to the commit message
16 u,utf8 recode into utf8 (default)
17 k,keep pass -k flag to git-mailinfo
18 keep-non-patch pass -b flag to git-mailinfo
19 keep-cr pass --keep-cr flag to git-mailsplit for mbox format
20 no-keep-cr do not pass --keep-cr flag to git-mailsplit independent of am.keepcr
21 c,scissors strip everything before a scissors line
22 whitespace= pass it through git-apply
23 ignore-space-change pass it through git-apply
24 ignore-whitespace pass it through git-apply
25 directory= pass it through git-apply
26 exclude= pass it through git-apply
27 include= pass it through git-apply
28 C= pass it through git-apply
29 p= pass it through git-apply
30 patch-format= format the patch(es) are in
31 reject pass it through git-apply
32 resolvemsg= override error message when patch failure occurs
33 continue continue applying patches after resolving a conflict
34 r,resolved synonyms for --continue
35 skip skip the current patch
36 abort restore the original branch and abort the patching operation.
37 committer-date-is-author-date lie about committer date
38 ignore-date use current timestamp for author date
39 rerere-autoupdate update the index with reused conflict resolution if possible
40 rebasing* (internal use for git-rebase)"
42 . git-sh-setup
43 . git-sh-i18n
44 prefix=$(git rev-parse --show-prefix)
45 set_reflog_action am
46 require_work_tree
47 cd_to_toplevel
49 git var GIT_COMMITTER_IDENT >/dev/null ||
50 die "$(gettext "You need to set your committer info first")"
52 if git rev-parse --verify -q HEAD >/dev/null
53 then
54 HAS_HEAD=yes
55 else
56 HAS_HEAD=
59 cmdline="git am"
60 if test '' != "$interactive"
61 then
62 cmdline="$cmdline -i"
64 if test '' != "$threeway"
65 then
66 cmdline="$cmdline -3"
69 sq () {
70 git rev-parse --sq-quote "$@"
73 stop_here () {
74 echo "$1" >"$dotest/next"
75 git rev-parse --verify -q HEAD >"$dotest/abort-safety"
76 exit 1
79 safe_to_abort () {
80 if test -f "$dotest/dirtyindex"
81 then
82 return 1
85 if ! test -s "$dotest/abort-safety"
86 then
87 return 0
90 abort_safety=$(cat "$dotest/abort-safety")
91 if test "z$(git rev-parse --verify -q HEAD)" = "z$abort_safety"
92 then
93 return 0
95 gettextln "You seem to have moved HEAD since the last 'am' failure.
96 Not rewinding to ORIG_HEAD" >&2
97 return 1
100 stop_here_user_resolve () {
101 if [ -n "$resolvemsg" ]; then
102 printf '%s\n' "$resolvemsg"
103 stop_here $1
105 eval_gettextln "When you have resolved this problem, run \"\$cmdline --continue\".
106 If you prefer to skip this patch, run \"\$cmdline --skip\" instead.
107 To restore the original branch and stop patching, run \"\$cmdline --abort\"."
109 stop_here $1
112 go_next () {
113 rm -f "$dotest/$msgnum" "$dotest/msg" "$dotest/msg-clean" \
114 "$dotest/patch" "$dotest/info"
115 echo "$next" >"$dotest/next"
116 this=$next
119 cannot_fallback () {
120 echo "$1"
121 gettextln "Cannot fall back to three-way merge."
122 exit 1
125 fall_back_3way () {
126 O_OBJECT=`cd "$GIT_OBJECT_DIRECTORY" && pwd`
128 rm -fr "$dotest"/patch-merge-*
129 mkdir "$dotest/patch-merge-tmp-dir"
131 # First see if the patch records the index info that we can use.
132 cmd="git apply $git_apply_opt --build-fake-ancestor" &&
133 cmd="$cmd "'"$dotest/patch-merge-tmp-index" "$dotest/patch"' &&
134 eval "$cmd" &&
135 GIT_INDEX_FILE="$dotest/patch-merge-tmp-index" \
136 git write-tree >"$dotest/patch-merge-base+" ||
137 cannot_fallback "$(gettext "Repository lacks necessary blobs to fall back on 3-way merge.")"
139 say "$(gettext "Using index info to reconstruct a base tree...")"
141 cmd='GIT_INDEX_FILE="$dotest/patch-merge-tmp-index"'
143 if test -z "$GIT_QUIET"
144 then
145 eval "$cmd git diff-index --cached --diff-filter=AM --name-status HEAD"
148 cmd="$cmd git apply --cached $git_apply_opt"' <"$dotest/patch"'
149 if eval "$cmd"
150 then
151 mv "$dotest/patch-merge-base+" "$dotest/patch-merge-base"
152 mv "$dotest/patch-merge-tmp-index" "$dotest/patch-merge-index"
153 else
154 cannot_fallback "$(gettext "Did you hand edit your patch?
155 It does not apply to blobs recorded in its index.")"
158 test -f "$dotest/patch-merge-index" &&
159 his_tree=$(GIT_INDEX_FILE="$dotest/patch-merge-index" git write-tree) &&
160 orig_tree=$(cat "$dotest/patch-merge-base") &&
161 rm -fr "$dotest"/patch-merge-* || exit 1
163 say "$(gettext "Falling back to patching base and 3-way merge...")"
165 # This is not so wrong. Depending on which base we picked,
166 # orig_tree may be wildly different from ours, but his_tree
167 # has the same set of wildly different changes in parts the
168 # patch did not touch, so recursive ends up canceling them,
169 # saying that we reverted all those changes.
171 eval GITHEAD_$his_tree='"$FIRSTLINE"'
172 export GITHEAD_$his_tree
173 if test -n "$GIT_QUIET"
174 then
175 GIT_MERGE_VERBOSITY=0 && export GIT_MERGE_VERBOSITY
177 git-merge-recursive $orig_tree -- HEAD $his_tree || {
178 git rerere $allow_rerere_autoupdate
179 die "$(gettext "Failed to merge in the changes.")"
181 unset GITHEAD_$his_tree
184 clean_abort () {
185 test $# = 0 || echo >&2 "$@"
186 rm -fr "$dotest"
187 exit 1
190 patch_format=
192 check_patch_format () {
193 # early return if patch_format was set from the command line
194 if test -n "$patch_format"
195 then
196 return 0
199 # we default to mbox format if input is from stdin and for
200 # directories
201 if test $# = 0 || test "x$1" = "x-" || test -d "$1"
202 then
203 patch_format=mbox
204 return 0
207 # otherwise, check the first few non-blank lines of the first
208 # patch to try to detect its format
210 # Start from first line containing non-whitespace
212 while test -z "$l1"
214 read l1 || break
215 done
216 read l2
217 read l3
218 case "$l1" in
219 "From "* | "From: "*)
220 patch_format=mbox
222 '# This series applies on GIT commit'*)
223 patch_format=stgit-series
225 "# HG changeset patch")
226 patch_format=hg
229 # if the second line is empty and the third is
230 # a From, Author or Date entry, this is very
231 # likely an StGIT patch
232 case "$l2,$l3" in
233 ,"From: "* | ,"Author: "* | ,"Date: "*)
234 patch_format=stgit
238 esac
240 esac
241 if test -z "$patch_format" &&
242 test -n "$l1" &&
243 test -n "$l2" &&
244 test -n "$l3"
245 then
246 # This begins with three non-empty lines. Is this a
247 # piece of e-mail a-la RFC2822? Grab all the headers,
248 # discarding the indented remainder of folded lines,
249 # and see if it looks like that they all begin with the
250 # header field names...
251 tr -d '\015' <"$1" |
252 sed -n -e '/^$/q' -e '/^[ ]/d' -e p |
253 sane_egrep -v '^[!-9;-~]+:' >/dev/null ||
254 patch_format=mbox
256 } < "$1" || clean_abort
259 split_patches () {
260 case "$patch_format" in
261 mbox)
262 if test t = "$keepcr"
263 then
264 keep_cr=--keep-cr
265 else
266 keep_cr=
268 git mailsplit -d"$prec" -o"$dotest" -b $keep_cr -- "$@" > "$dotest/last" ||
269 clean_abort
271 stgit-series)
272 if test $# -ne 1
273 then
274 clean_abort "$(gettext "Only one StGIT patch series can be applied at once")"
276 series_dir=`dirname "$1"`
277 series_file="$1"
278 shift
280 set x
281 while read filename
283 set "$@" "$series_dir/$filename"
284 done
285 # remove the safety x
286 shift
287 # remove the arg coming from the first-line comment
288 shift
289 } < "$series_file" || clean_abort
290 # set the patch format appropriately
291 patch_format=stgit
292 # now handle the actual StGIT patches
293 split_patches "$@"
295 stgit)
296 this=0
297 for stgit in "$@"
299 this=`expr "$this" + 1`
300 msgnum=`printf "%0${prec}d" $this`
301 # Perl version of StGIT parse_patch. The first nonemptyline
302 # not starting with Author, From or Date is the
303 # subject, and the body starts with the next nonempty
304 # line not starting with Author, From or Date
305 perl -ne 'BEGIN { $subject = 0 }
306 if ($subject > 1) { print ; }
307 elsif (/^\s+$/) { next ; }
308 elsif (/^Author:/) { s/Author/From/ ; print ;}
309 elsif (/^(From|Date)/) { print ; }
310 elsif ($subject) {
311 $subject = 2 ;
312 print "\n" ;
313 print ;
314 } else {
315 print "Subject: ", $_ ;
316 $subject = 1;
318 ' < "$stgit" > "$dotest/$msgnum" || clean_abort
319 done
320 echo "$this" > "$dotest/last"
321 this=
322 msgnum=
325 this=0
326 for hg in "$@"
328 this=$(( $this + 1 ))
329 msgnum=$(printf "%0${prec}d" $this)
330 # hg stores changeset metadata in #-commented lines preceding
331 # the commit message and diff(s). The only metadata we care about
332 # are the User and Date (Node ID and Parent are hashes which are
333 # only relevant to the hg repository and thus not useful to us)
334 # Since we cannot guarantee that the commit message is in
335 # git-friendly format, we put no Subject: line and just consume
336 # all of the message as the body
337 LANG=C LC_ALL=C perl -M'POSIX qw(strftime)' -ne 'BEGIN { $subject = 0 }
338 if ($subject) { print ; }
339 elsif (/^\# User /) { s/\# User/From:/ ; print ; }
340 elsif (/^\# Date /) {
341 my ($hashsign, $str, $time, $tz) = split ;
342 $tz = sprintf "%+05d", (0-$tz)/36;
343 print "Date: " .
344 strftime("%a, %d %b %Y %H:%M:%S ",
345 localtime($time))
346 . "$tz\n";
347 } elsif (/^\# /) { next ; }
348 else {
349 print "\n", $_ ;
350 $subject = 1;
352 ' <"$hg" >"$dotest/$msgnum" || clean_abort
353 done
354 echo "$this" >"$dotest/last"
355 this=
356 msgnum=
359 if test -n "$patch_format"
360 then
361 clean_abort "$(eval_gettext "Patch format \$patch_format is not supported.")"
362 else
363 clean_abort "$(gettext "Patch format detection failed.")"
366 esac
369 prec=4
370 dotest="$GIT_DIR/rebase-apply"
371 sign= utf8=t keep= keepcr= skip= interactive= resolved= rebasing= abort=
372 resolvemsg= resume= scissors= no_inbody_headers=
373 git_apply_opt=
374 committer_date_is_author_date=
375 ignore_date=
376 allow_rerere_autoupdate=
378 if test "$(git config --bool --get am.keepcr)" = true
379 then
380 keepcr=t
383 while test $# != 0
385 case "$1" in
386 -i|--interactive)
387 interactive=t ;;
388 -b|--binary)
389 gettextln >&2 "The -b/--binary option has been a no-op for long time, and
390 it will be removed. Please do not use it anymore."
392 -3|--3way)
393 threeway=t ;;
394 -s|--signoff)
395 sign=t ;;
396 -u|--utf8)
397 utf8=t ;; # this is now default
398 --no-utf8)
399 utf8= ;;
400 -k|--keep)
401 keep=t ;;
402 --keep-non-patch)
403 keep=b ;;
404 -c|--scissors)
405 scissors=t ;;
406 --no-scissors)
407 scissors=f ;;
408 -r|--resolved|--continue)
409 resolved=t ;;
410 --skip)
411 skip=t ;;
412 --abort)
413 abort=t ;;
414 --rebasing)
415 rebasing=t threeway=t ;;
416 --resolvemsg)
417 shift; resolvemsg=$1 ;;
418 --whitespace|--directory|--exclude|--include)
419 git_apply_opt="$git_apply_opt $(sq "$1=$2")"; shift ;;
420 -C|-p)
421 git_apply_opt="$git_apply_opt $(sq "$1$2")"; shift ;;
422 --patch-format)
423 shift ; patch_format="$1" ;;
424 --reject|--ignore-whitespace|--ignore-space-change)
425 git_apply_opt="$git_apply_opt $1" ;;
426 --committer-date-is-author-date)
427 committer_date_is_author_date=t ;;
428 --ignore-date)
429 ignore_date=t ;;
430 --rerere-autoupdate|--no-rerere-autoupdate)
431 allow_rerere_autoupdate="$1" ;;
432 -q|--quiet)
433 GIT_QUIET=t ;;
434 --keep-cr)
435 keepcr=t ;;
436 --no-keep-cr)
437 keepcr=f ;;
439 shift; break ;;
441 usage ;;
442 esac
443 shift
444 done
446 # If the dotest directory exists, but we have finished applying all the
447 # patches in them, clear it out.
448 if test -d "$dotest" &&
449 test -f "$dotest/last" &&
450 test -f "$dotest/next" &&
451 last=$(cat "$dotest/last") &&
452 next=$(cat "$dotest/next") &&
453 test $# != 0 &&
454 test "$next" -gt "$last"
455 then
456 rm -fr "$dotest"
459 if test -d "$dotest" && test -f "$dotest/last" && test -f "$dotest/next"
460 then
461 case "$#,$skip$resolved$abort" in
462 0,*t*)
463 # Explicit resume command and we do not have file, so
464 # we are happy.
465 : ;;
467 # No file input but without resume parameters; catch
468 # user error to feed us a patch from standard input
469 # when there is already $dotest. This is somewhat
470 # unreliable -- stdin could be /dev/null for example
471 # and the caller did not intend to feed us a patch but
472 # wanted to continue unattended.
473 test -t 0
476 false
478 esac ||
479 die "$(eval_gettext "previous rebase directory \$dotest still exists but mbox given.")"
480 resume=yes
482 case "$skip,$abort" in
483 t,t)
484 die "$(gettext "Please make up your mind. --skip or --abort?")"
487 git rerere clear
488 git read-tree --reset -u HEAD HEAD
489 orig_head=$(cat "$GIT_DIR/ORIG_HEAD")
490 git reset HEAD
491 git update-ref ORIG_HEAD $orig_head
494 if test -f "$dotest/rebasing"
495 then
496 exec git rebase --abort
498 git rerere clear
499 if safe_to_abort
500 then
501 git read-tree --reset -u HEAD ORIG_HEAD
502 git reset ORIG_HEAD
504 rm -fr "$dotest"
505 exit ;;
506 esac
507 rm -f "$dotest/dirtyindex"
508 else
509 # Possible stray $dotest directory in the independent-run
510 # case; in the --rebasing case, it is upto the caller
511 # (git-rebase--am) to take care of stray directories.
512 if test -d "$dotest" && test -z "$rebasing"
513 then
514 case "$skip,$resolved,$abort" in
515 ,,t)
516 rm -fr "$dotest"
517 exit 0
520 die "$(eval_gettext "Stray \$dotest directory found.
521 Use \"git am --abort\" to remove it.")"
523 esac
526 # Make sure we are not given --skip, --continue, nor --abort
527 test "$skip$resolved$abort" = "" ||
528 die "$(gettext "Resolve operation not in progress, we are not resuming.")"
530 # Start afresh.
531 mkdir -p "$dotest" || exit
533 if test -n "$prefix" && test $# != 0
534 then
535 first=t
536 for arg
538 test -n "$first" && {
539 set x
540 first=
542 if is_absolute_path "$arg"
543 then
544 set "$@" "$arg"
545 else
546 set "$@" "$prefix$arg"
548 done
549 shift
552 check_patch_format "$@"
554 split_patches "$@"
556 # -i can and must be given when resuming; everything
557 # else is kept
558 echo " $git_apply_opt" >"$dotest/apply-opt"
559 echo "$threeway" >"$dotest/threeway"
560 echo "$sign" >"$dotest/sign"
561 echo "$utf8" >"$dotest/utf8"
562 echo "$keep" >"$dotest/keep"
563 echo "$scissors" >"$dotest/scissors"
564 echo "$no_inbody_headers" >"$dotest/no_inbody_headers"
565 echo "$GIT_QUIET" >"$dotest/quiet"
566 echo 1 >"$dotest/next"
567 if test -n "$rebasing"
568 then
569 : >"$dotest/rebasing"
570 else
571 : >"$dotest/applying"
572 if test -n "$HAS_HEAD"
573 then
574 git update-ref ORIG_HEAD HEAD
575 else
576 git update-ref -d ORIG_HEAD >/dev/null 2>&1
581 git update-index -q --refresh
583 case "$resolved" in
585 case "$HAS_HEAD" in
587 files=$(git ls-files) ;;
589 files=$(git diff-index --cached --name-only HEAD --) ;;
590 esac || exit
591 if test "$files"
592 then
593 test -n "$HAS_HEAD" && : >"$dotest/dirtyindex"
594 die "$(eval_gettext "Dirty index: cannot apply patches (dirty: \$files)")"
596 esac
598 # Now, decide what command line options we will give to the git
599 # commands we invoke, based on the result of parsing command line
600 # options and previous invocation state stored in $dotest/ files.
602 if test "$(cat "$dotest/utf8")" = t
603 then
604 utf8=-u
605 else
606 utf8=-n
608 keep=$(cat "$dotest/keep")
609 case "$keep" in
611 keep=-k ;;
613 keep=-b ;;
615 keep= ;;
616 esac
617 case "$(cat "$dotest/scissors")" in
619 scissors=--scissors ;;
621 scissors=--no-scissors ;;
622 esac
623 if test "$(cat "$dotest/no_inbody_headers")" = t
624 then
625 no_inbody_headers=--no-inbody-headers
626 else
627 no_inbody_headers=
629 if test "$(cat "$dotest/quiet")" = t
630 then
631 GIT_QUIET=t
633 if test "$(cat "$dotest/threeway")" = t
634 then
635 threeway=t
637 git_apply_opt=$(cat "$dotest/apply-opt")
638 if test "$(cat "$dotest/sign")" = t
639 then
640 SIGNOFF=`git var GIT_COMMITTER_IDENT | sed -e '
641 s/>.*/>/
642 s/^/Signed-off-by: /'
644 else
645 SIGNOFF=
648 last=`cat "$dotest/last"`
649 this=`cat "$dotest/next"`
650 if test "$skip" = t
651 then
652 this=`expr "$this" + 1`
653 resume=
656 while test "$this" -le "$last"
658 msgnum=`printf "%0${prec}d" $this`
659 next=`expr "$this" + 1`
660 test -f "$dotest/$msgnum" || {
661 resume=
662 go_next
663 continue
666 # If we are not resuming, parse and extract the patch information
667 # into separate files:
668 # - info records the authorship and title
669 # - msg is the rest of commit log message
670 # - patch is the patch body.
672 # When we are resuming, these files are either already prepared
673 # by the user, or the user can tell us to do so by --continue flag.
674 case "$resume" in
676 if test -f "$dotest/rebasing"
677 then
678 commit=$(sed -e 's/^From \([0-9a-f]*\) .*/\1/' \
679 -e q "$dotest/$msgnum") &&
680 test "$(git cat-file -t "$commit")" = commit ||
681 stop_here $this
682 git cat-file commit "$commit" |
683 sed -e '1,/^$/d' >"$dotest/msg-clean"
684 echo "$commit" >"$dotest/original-commit"
685 get_author_ident_from_commit "$commit" >"$dotest/author-script"
686 git diff-tree --root --binary --full-index "$commit" >"$dotest/patch"
687 else
688 git mailinfo $keep $no_inbody_headers $scissors $utf8 "$dotest/msg" "$dotest/patch" \
689 <"$dotest/$msgnum" >"$dotest/info" ||
690 stop_here $this
692 # skip pine's internal folder data
693 sane_grep '^Author: Mail System Internal Data$' \
694 <"$dotest"/info >/dev/null &&
695 go_next && continue
697 test -s "$dotest/patch" || {
698 eval_gettextln "Patch is empty. Was it split wrong?
699 If you would prefer to skip this patch, instead run \"\$cmdline --skip\".
700 To restore the original branch and stop patching run \"\$cmdline --abort\"."
701 stop_here $this
703 rm -f "$dotest/original-commit" "$dotest/author-script"
705 sed -n '/^Subject/ s/Subject: //p' "$dotest/info"
706 echo
707 cat "$dotest/msg"
709 git stripspace > "$dotest/msg-clean"
712 esac
714 if test -f "$dotest/author-script"
715 then
716 eval $(cat "$dotest/author-script")
717 else
718 GIT_AUTHOR_NAME="$(sed -n '/^Author/ s/Author: //p' "$dotest/info")"
719 GIT_AUTHOR_EMAIL="$(sed -n '/^Email/ s/Email: //p' "$dotest/info")"
720 GIT_AUTHOR_DATE="$(sed -n '/^Date/ s/Date: //p' "$dotest/info")"
723 if test -z "$GIT_AUTHOR_EMAIL"
724 then
725 gettextln "Patch does not have a valid e-mail address."
726 stop_here $this
729 export GIT_AUTHOR_NAME GIT_AUTHOR_EMAIL GIT_AUTHOR_DATE
731 case "$resume" in
733 if test '' != "$SIGNOFF"
734 then
735 LAST_SIGNED_OFF_BY=`
736 sed -ne '/^Signed-off-by: /p' \
737 "$dotest/msg-clean" |
738 sed -ne '$p'
740 ADD_SIGNOFF=`
741 test "$LAST_SIGNED_OFF_BY" = "$SIGNOFF" || {
742 test '' = "$LAST_SIGNED_OFF_BY" && echo
743 echo "$SIGNOFF"
745 else
746 ADD_SIGNOFF=
749 if test -s "$dotest/msg-clean"
750 then
751 cat "$dotest/msg-clean"
753 if test '' != "$ADD_SIGNOFF"
754 then
755 echo "$ADD_SIGNOFF"
757 } >"$dotest/final-commit"
760 case "$resolved$interactive" in
762 # This is used only for interactive view option.
763 git diff-index -p --cached HEAD -- >"$dotest/patch"
765 esac
766 esac
768 resume=
769 if test "$interactive" = t
770 then
771 test -t 0 ||
772 die "$(gettext "cannot be interactive without stdin connected to a terminal.")"
773 action=again
774 while test "$action" = again
776 gettextln "Commit Body is:"
777 echo "--------------------------"
778 cat "$dotest/final-commit"
779 echo "--------------------------"
780 # TRANSLATORS: Make sure to include [y], [n], [e], [v] and [a]
781 # in your translation. The program will only accept English
782 # input at this point.
783 gettext "Apply? [y]es/[n]o/[e]dit/[v]iew patch/[a]ccept all "
784 read reply
785 case "$reply" in
786 [yY]*) action=yes ;;
787 [aA]*) action=yes interactive= ;;
788 [nN]*) action=skip ;;
789 [eE]*) git_editor "$dotest/final-commit"
790 action=again ;;
791 [vV]*) action=again
792 git_pager "$dotest/patch" ;;
793 *) action=again ;;
794 esac
795 done
796 else
797 action=yes
800 if test $action = skip
801 then
802 go_next
803 continue
806 if test -x "$GIT_DIR"/hooks/applypatch-msg
807 then
808 "$GIT_DIR"/hooks/applypatch-msg "$dotest/final-commit" ||
809 stop_here $this
812 if test -f "$dotest/final-commit"
813 then
814 FIRSTLINE=$(sed 1q "$dotest/final-commit")
815 else
816 FIRSTLINE=""
819 say "$(eval_gettext "Applying: \$FIRSTLINE")"
821 case "$resolved" in
823 # When we are allowed to fall back to 3-way later, don't give
824 # false errors during the initial attempt.
825 squelch=
826 if test "$threeway" = t
827 then
828 squelch='>/dev/null 2>&1 '
830 eval "git apply $squelch$git_apply_opt"' --index "$dotest/patch"'
831 apply_status=$?
834 # Resolved means the user did all the hard work, and
835 # we do not have to do any patch application. Just
836 # trust what the user has in the index file and the
837 # working tree.
838 resolved=
839 git diff-index --quiet --cached HEAD -- && {
840 gettextln "No changes - did you forget to use 'git add'?
841 If there is nothing left to stage, chances are that something else
842 already introduced the same changes; you might want to skip this patch."
843 stop_here_user_resolve $this
845 unmerged=$(git ls-files -u)
846 if test -n "$unmerged"
847 then
848 gettextln "You still have unmerged paths in your index
849 did you forget to use 'git add'?"
850 stop_here_user_resolve $this
852 apply_status=0
853 git rerere
855 esac
857 if test $apply_status != 0 && test "$threeway" = t
858 then
859 if (fall_back_3way)
860 then
861 # Applying the patch to an earlier tree and merging the
862 # result may have produced the same tree as ours.
863 git diff-index --quiet --cached HEAD -- && {
864 say "$(gettext "No changes -- Patch already applied.")"
865 go_next
866 continue
868 # clear apply_status -- we have successfully merged.
869 apply_status=0
872 if test $apply_status != 0
873 then
874 eval_gettextln 'Patch failed at $msgnum $FIRSTLINE'
875 if test "$(git config --bool advice.amworkdir)" != false
876 then
877 eval_gettextln 'The copy of the patch that failed is found in:
878 $dotest/patch'
880 stop_here_user_resolve $this
883 if test -x "$GIT_DIR"/hooks/pre-applypatch
884 then
885 "$GIT_DIR"/hooks/pre-applypatch || stop_here $this
888 tree=$(git write-tree) &&
889 commit=$(
890 if test -n "$ignore_date"
891 then
892 GIT_AUTHOR_DATE=
894 parent=$(git rev-parse --verify -q HEAD) ||
895 say >&2 "$(gettext "applying to an empty history")"
897 if test -n "$committer_date_is_author_date"
898 then
899 GIT_COMMITTER_DATE="$GIT_AUTHOR_DATE"
900 export GIT_COMMITTER_DATE
901 fi &&
902 git commit-tree $tree ${parent:+-p} $parent <"$dotest/final-commit"
903 ) &&
904 git update-ref -m "$GIT_REFLOG_ACTION: $FIRSTLINE" HEAD $commit $parent ||
905 stop_here $this
907 if test -f "$dotest/original-commit"; then
908 echo "$(cat "$dotest/original-commit") $commit" >> "$dotest/rewritten"
911 if test -x "$GIT_DIR"/hooks/post-applypatch
912 then
913 "$GIT_DIR"/hooks/post-applypatch
916 go_next
917 done
919 if test -s "$dotest"/rewritten; then
920 git notes copy --for-rewrite=rebase < "$dotest"/rewritten
921 if test -x "$GIT_DIR"/hooks/post-rewrite; then
922 "$GIT_DIR"/hooks/post-rewrite rebase < "$dotest"/rewritten
926 # If am was called with --rebasing (from git-rebase--am), it's up to
927 # the caller to take care of housekeeping.
928 if ! test -f "$dotest/rebasing"
929 then
930 rm -fr "$dotest"
931 git gc --auto